%global dlrn 1
%define upstream_version 11.0.0
%{!?upstream_version: %global upstream_version %{version}%{?milestone}}
%global drv_vendor VMware
%global srcname vmware-nsx
%global docpath doc/build/html
%global service neutron
%global pyname vmware_nsx

%global with_doc 0

Name:           python-networking-%{srcname}
Version: 	11.0.0
Release: 	1%{?dist}
Provides: 	python2-networking-vmware-nsx = %{version}-%{release}
Summary:        %{drv_vendor} OpenStack Neutron driver

License:        ASL 2.0
# TODO: really, there are no packages on PyPI or anywhere else
URL:            https://pypi.python.org/pypi/%{srcname}
Source0: 	http://tarballs.openstack.org/%{srcname}/%{srcname}-%{version}.tar.gz

# patches_ignore=DROP-IN-RPM
# patches_base=11.0.0
Patch0001: 0001-NSX-V-complete-init-of-fwaas-core-plugin.patch
Patch0002: 0002-Add-NSXv3-LBaaS-driver-config-for-devstack.patch
Patch0003: 0003-NSXv3-Fix-L7-rule-create-delete-base-on-latest-API.patch
Patch0004: 0004-NSXv3-Fix-a-typo-in-LBaaS-member_mgr.patch
Patch0005: 0005-Updated-from-global-requirements.patch
Patch0006: 0006-NSX-V-add-exception-log-if-router-create-fails.patch
Patch0007: 0007-NSX-V-check-md-proxy-handler-exists-before-usage.patch
Patch0008: 0008-NSXv3-Handle-floating-ip-for-loadbalancer-VIP.patch
Patch0009: 0009-NSXv3-Fix-loadbalancer-stats-exception.patch
Patch0010: 0010-NSXv3-Change-LB-rule-match-type-to-REGEX.patch
Patch0011: 0011-NSXv3-Change-reponse-code-for-L7-redirect-and-reject.patch
Patch0012: 0012-NSXv3-Fix-LB-pool-algorithm.patch
Patch0013: 0013-zuul-v3-gate-changes.patch
Patch0014: 0014-NSXv3-Update-router-advertise_lb_vip.patch
Patch0015: 0015-NSX-V-fix-exclude-list-counting.patch
Patch0016: 0016-NSXv-Recover-from-LBaaSv2-HM-inconsistency.patch
Patch0017: 0017-NSX-V-add-shared-router-logs.patch

BuildArch:      noarch
BuildRequires:  openstack-macros
BuildRequires:  python2-devel
BuildRequires:  python-mock
BuildRequires:  python-oslo-sphinx
BuildRequires:  python-pbr
BuildRequires:  python-setuptools
BuildRequires:  python-sphinx
BuildRequires:  python-tenacity
BuildRequires:  python-vmware-nsxlib
# Required for config file generation
BuildRequires:  python-debtcollector
BuildRequires:  python-oslo-config >= 2:4.0.0
BuildRequires:  python-oslo-i18n >= 2.1.0
BuildRequires:  python-oslo-vmware >= 2.17.0
BuildRequires:  python-neutron

Requires:       python-decorator
Requires:       python-enum34
Requires:       python-eventlet
Requires:       python-httplib2 >= 0.7.5
Requires:       python-netaddr >= 0.7.13
Requires:       python-neutron
Requires:       python-neutron-lib >= 1.9.0
Requires:       python-openstackclient >= 3.3.0
Requires:       python-osc-lib >= 1.7.0
Requires:       python-oslo-concurrency >= 3.8.0
Requires:       python-oslo-config >= 2:4.0.0
Requires:       python-oslo-db >= 4.24.0
Requires:       python-oslo-i18n >= 2.1.0
Requires:       python-oslo-log >= 3.22.0
Requires:       python-oslo-serialization >= 1.10.0
Requires:       python-oslo-service >= 1.10.0
Requires:       python-oslo-utils >= 3.20.0
Requires:       python-oslo-vmware >= 2.17.0
Requires:       python-pbr >= 2.0.0
Requires:       python-prettytable
Requires:       python-six >= 1.9.0
Requires:       python-sqlalchemy >= 1.0.10
Requires:       python-stevedore >= 1.20.0
Requires:       python-tenacity >= 3.2.1
Requires:       python-tooz >= 1.47.0
Requires:       python-vmware-nsxlib

%description
This package contains %{drv_vendor} networking driver for OpenStack Neutron.


%if 0%{?with_doc}
%package doc
Summary:        %{summary} documentation
Requires:       %{name} = %{version}-%{release}


%description doc
This package contains documentation for %{drv_vendor} networking driver for
OpenStack Neutron.
%endif

%prep
%setup -q -n %{srcname}-%{upstream_version}

%patch0001 -p1
%patch0002 -p1
%patch0003 -p1
%patch0004 -p1
%patch0005 -p1
%patch0006 -p1
%patch0007 -p1
%patch0008 -p1
%patch0009 -p1
%patch0010 -p1
%patch0011 -p1
%patch0012 -p1
%patch0013 -p1
%patch0014 -p1
%patch0015 -p1
%patch0016 -p1
%patch0017 -p1

rm requirements.txt test-requirements.txt


%build
%{__python2} setup.py build

%if 0%{?with_doc}
%{__python2} setup.py build_sphinx
rm %{docpath}/.buildinfo
%endif


%install
export PBR_VERSION=%{version}
export SKIP_PIP_INSTALL=1
%{__python2} setup.py install --skip-build --root %{buildroot}

# Build config file
PYTHONPATH=. tools/generate_config_file_samples.sh

# Move config files to proper location
install -d -m 755 %{buildroot}%{_sysconfdir}/%{service}/plugins/vmware
mv etc/nsx.ini.sample %{buildroot}%{_sysconfdir}/%{service}/plugins/vmware/nsx.ini

%files
%license LICENSE
%{_bindir}/nsx-migration
%{_bindir}/neutron-check-nsx-config
%{_bindir}/nsxadmin
%{python2_sitelib}/%{pyname}
%{python2_sitelib}/%{pyname}-%{version}-py%{python2_version}.egg-info
%dir %{_sysconfdir}/%{service}/plugins/vmware
%config(noreplace) %attr(0640, root, %{service}) %{_sysconfdir}/%{service}/plugins/vmware/*.ini


%if 0%{?with_doc}
%files doc
%license LICENSE
%doc %{docpath}
%endif

%changelog
* Mon Nov 20 2017 Jason Joyce <jjoyce@redhat.com> 11.0.0-1
- NSX|V add shared router logs
- NSXv: Recover from LBaaSv2 HM inconsistency
- NSX|V fix exclude list counting
- NSXv3: Update router advertise_lb_vip
- zuul v3 gate changes
- NSXv3: Fix LB pool algorithm
- NSXv3: Change reponse code for L7 redirect and reject
- NSXv3: Change LB rule match type to REGEX
- NSXv3: Fix loadbalancer stats exception
- NSXv3: Handle floating ip for loadbalancer VIP
- NSX|V: check md proxy handler exists before usage
- NSX|V: add exception log if router create fails
- Updated from global requirements
- NSXv3: Fix a typo in LBaaS member_mgr
- NSXv3: Fix L7 rule create/delete base on latest API
- Add NSXv3 LBaaS driver config for devstack
- NSX|V complete init of fwaas core plugin
- Update to 11.0.0

